100 REMark PC versus QL by Dilwyn Jones
110 INITIALISE
120 skill = NEW_GAME : IF skill = -21 THEN STOP
130 NEXT_LIFE
140 REMark loop count slows the PCs down by expanding the PC columns
150 REMark only every 1 in limit_count passes of the loop
160 loop_count = 0 : REMark allows some degree of speed control
170 REPeat game_loop
180   REMark the next line ensures that the game speeds up slightly
190   REMark as the score gets higher, and as the number of columns
200   REMark gets higher too.
210   limit_count = 10+((skill+1)*(lives+2))-INT(score/500)
220   IF limit_count < 10 : limit_count = 10
230   oldx = x : oldy = y : k$ = INKEY$
240   x = x + (k$=CHR$(200) AND x<13) - (k$=CHR$(192) AND x>1)
250   y = y + (k$=CHR$(216) AND y<19) - (k$=CHR$(208) AND y>3)
260   IF column(x) < y THEN 
270     x = oldx : y = oldy
280   ELSE 
290     IF column(x) = y THEN 
300       REMark QL at top of column, so squashing a PC earns points
310       score = score + 20 - y + (9-skill) : column(x) = column(x) + 1
320       IF column(x) < 20 THEN 
330         AT column(x),(3*x)-1 : PAPER 2 : INK 7
340         PRINT 'PC' : PAPER 6 : INK 0
350       END IF 
360       AT 0,34 : PRINT score : BEEP 100,76-(4*y)
370     END IF 
380     IF x <> oldx OR y <> oldy THEN 
390       REMark QL has moved, so blank out old and show new position
400       AT oldy,(oldx * 3) - 1 : PAPER 6 : PRINT '  ' : AT y,(x * 3) - 1
410       PAPER 0 : INK 7 : PRINT'QL' : PAPER 6 : INK 0
420     END IF 
430   END IF 
440   columns = 2 + INT(score/300) : IF columns > 13 THEN columns = 13
450   number = RND(1 TO columns) : REMark choose a column to grow
460   REMark if QL is blocking it, column can't grow
470   IF x = number AND y = column(number)-1 THEN NEXT game_loop
480   REMark make the game start off more quickly and slow down later
490   loop_count = loop_count + 1
500   IF loop_count < limit_count THEN NEXT game_loop
510   loop_count = 0 : REMark reset it
520   IF column(number) < 20 THEN 
530     AT column(number),(number*3)-1 : PAPER 2 : INK 7 : PRINT '  '
540   END IF 
550   column(number) = column(number) - 1 : AT column(number),(number*3)-1
560   PAPER 2 : INK 7 : PRINT 'PC' : PAPER 6 : INK 0
570   REMark unless reached line 3, we have not been beaten yet
580   IF column(number) > 3 THEN NEXT game_loop
590   REMark oops, the PCs have overrun the QLs
600   AT 24,0 : PAPER 6 : CLS 3 : PAPER 2 : INK 7
610   FOR a=19 TO 2 STEP -1:AT a,(number * 3)-1:PRINT'PC':BEEP 100,95-5*a
620   AT 2,0 : CLS 3 : FLASH 1
630   PRINT' PC PC PC PC PC PC PC PC PC PC PC PC PC PC';
640   AT 23,10 : msg = RND(1 TO 5) : PAPER 3 : INK 7
650   SELect ON msg
660     =1 : PRINT' OOPS, OH DEAR... !!!! '
670     =2 : PRINT' HOW CARELESS OF YOU! '
680     =3 : PRINT' YOU LET THE PC INVADE! '
690     =4 : PRINT' YOU LET THE QL DOWN! '
700     =5 : PRINT' THE PCS HAVE TAKEN OVER! '
710   END SELect 
720   AT y,(x*3)-1 : PAPER 2 : INK 7 : FLASH 1 : PRINT '**' : FLASH 0
730   FOR a = 1 TO 13 : column (a) = 20 : BEEP 100,70-5*a
740   AT y,(x*3)-1 : PAPER 6 : INK 0 : PRINT '  '
750   lives = lives - 1 : WAIT 3
760   REMark any lives left?
770   IF lives > 0 THEN NEXT_LIFE : NEXT game_loop
780   IF score <= hiscore THEN 
790     skill = NEW_GAME : IF skill = -21 THEN EXIT game_loop
800     NEXT_LIFE : NEXT game_loop
810   END IF 
820   REMark give a ranking based on score
830   AT 24,0 : PRINT'Your Ranking:';
840   SELect ON score
850     =0 TO 3000 : PRINT'More practise needed!';
860     =3001 TO 5000 : PRINT'Average...';
870     =5001 TO 10000 : PRINT'A true defender of the QL';
880     =REMAINDER : PRINT'A knight of the land of QLs';
890   END SELect 
900   WAIT 3: CLS: AT 2,6: PAPER 0: INK 5: PRINT' CONGRATULATIONS!!! ';
910   PAPER 6 : INK 1 : PRINT\\\TO 11;score;' beats ';
920   INK 0 : PRINT\\\TO 5;hiscore;' by ';name$
930   AT 15,8 : INPUT'Enter your name ';name$ : hiscore = score
940   skill = NEW_GAME : IF skill = -21 THEN EXIT game_loop : REMark ESC
950   NEXT_LIFE
960 END REPeat game_loop
970 STOP
980 :
990 DEFine PROCedure INITIALISE
1000   MODE 8 : WINDOW 512,256,0,0 : PAPER 6 : INK 0 : CLS : CSIZE 2,0
1010   DIM column(13) : REMark column co-ordinates
1020   FOR a = 1 TO 13 : column(a) = 20
1030   hiscore = 3000 : name$ = 'Dilwyn Jones'
1040 END DEFine INITIALISE
1050 :
1060 DEFine FuNction NEW_GAME
1070   PAPER 6 : CLS : score = 0 : columns = 2 : lives = 3 : PAPER 1
1080   CSIZE 2,1 : INK 6 : AT 1,10 : PRINT' THE PC VERSUS THE QL '
1090   CSIZE 2,0 : PAPER 6 : INK 0 : PRINT \\\ TO 17;'NEW GAME'
1100   PRINT TO 16;FILL$('-',10)
1110   AT 10,4 : PRINT 'Skill level 0 (hard) - 9 (easy) ? ';
1120   REPeat loop
1130     skl = CODE(INKEY$(-1))-48
1140     SELect ON skl = -21,0 TO 9 : EXIT loop
1150   END REPeat loop
1160   IF skl >= 0 THEN PRINT skl : ELSE PRINT'ESC'
1170   PAUSE 50 : RETurn skl
1180 END DEFine NEW_GAME
1190 :
1200 DEFine PROCedure NEXT_LIFE
1210   PAPER 6 : CLS : x = 5 : y = 3 : PRINT 'SKILL ';skill : AT 0,12
1220   INK 3 : UNDER 1 : PRINT'PC versus QL' : UNDER 0 : AT 0,28 : PAPER 6
1230   CLS 4 : AT 0,28 : PAPER 6 : CLS 4
1240   FOR a = 1 TO lives - 1
1250     PAPER 0 : INK 7 : PRINT'QL'; : PAPER 6 : PRINT ' ';
1260   END FOR a
1270   AT 2,11 : PAPER 1 : INK 7 : CLS 3 : PRINT 'THE LAND OF THE QLS'
1280   AT 20,17 : PAPER 2,0,3 : INK 7 : CLS 3
1290   PRINT 'PC LAND': PAPER 4 : INK 0 : AT 24,0 : CLS 3
1300   PRINT' Use the cursor arrow keys to move the QL ';
1310   PAPER 6 : AT 0,34 : PRINT score
1320   AT 22,0 : PRINT 'HI-SCORE ';hiscore;' by ';name$
1330   REMark deliver a replacement QL
1340   FOR a = 38*12 TO ((3*x)-1)*12 STEP -2
1350     CURSOR a,30 : PAPER 0 : INK 7 : PRINT'QL';
1360     PAPER 6 : PRINT ' '; : BEEP 100,20 : REMark PAUSE 1
1370   END FOR a
1380   PAPER 6 : INK 0
1390 END DEFine NEXT_LIFE
1400 :
1410 DEFine PROCedure WAIT (seconds)
1420   LOCal time,loop
1430   REMark provides a fixed wait time, not interrupted by keypress
1440   time = DATE
1450   REPeat loop : IF DATE>(time+seconds) THEN EXIT loop
1460 END DEFine WAIT
